# frozen_string_literal: true

require 'lite/errors'

module Lite
  module Service
    module Errors

      def errors
        @errors ||= Lite::Errors::Messages.new
      end

      def errored?
        !errors.empty?
      end

      def fail!
        raise Lite::Service::ValidationError
      end

      def failure?
        called? && errored?
      end

      def result!
        result if valid?
      end

      def success?
        called? && !errored?
      end

      def validate!
        return true if success?

        fail!
      end

      alias valid? validate!

    end
  end
end
